Support -N option to only bootstrap the grml_chroot and skip building of [files for...
[grml-live.git] / etc / grml / fai / config / hooks / updatebase.GRMLBASE
index b47973c..e38754d 100755 (executable)
@@ -1,15 +1,73 @@
-#!/bin/sh
+#!/bin/bash
 # Filename:      /etc/grml/fai/config/hooks/updatebase.GRMLBASE
-# Purpose:       skip task updatebase of FAI when running softupdate
+# Purpose:       Updates the base packages of the system, prepare chroot for instsoft
 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2 or any later version.
-# Latest change: Sun Dec 09 19:07:51 CET 2007 [mika]
 ################################################################################
 
+set -u
+set -e
+
+# visualize chroot inside zsh:
+echo grml_chroot > $target/etc/debian_chroot
+
+HOSTNAME=''
+[ -r /etc/grml/grml-live.conf ]  && . /etc/grml/grml-live.conf
+[ -r /etc/grml/grml-live.local ] && . /etc/grml/grml-live.local
+[ -n "$HOSTNAME" ] || HOSTNAME=grml
+echo "$HOSTNAME" > $target/etc/hostname
+
 if [ "$FAI_ACTION" = "softupdate" ] ; then
+   echo "Action $FAI_ACTION of FAI (hooks/updatebase.GRMLBASE) via grml-live running"
+
+   ## we want to use our own sources.list:
    skiptask updatebase
+
+   ## based on FAI's lib/updatebase:
+   # some packages must access /proc even in chroot environment
+   if ! [ -d $FAI_ROOT/proc/1 ] ; then
+      mount -t proc proc $FAI_ROOT/proc || true
+   fi
+   # some packages must access /sys even in chroot environment
+   if ! [ -d $FAI_ROOT/sys/kernel ] ; then
+      mount -t sysfs sysfs $FAI_ROOT/sys
+   fi
+   # if we are using udev, also mount it into $FAI_ROOT
+   if [ -f /etc/init.d/udev ] ; then
+      mount --bind /dev $FAI_ROOT/dev || true
+   fi
+
+   mount -t devpts devpts $FAI_ROOT/dev/pts || true
+
+   # skip the task if we want to build a new ISO only,
+   # this means we do NOT update any packages
+   if [ -n "$BUILD_ONLY" ] ; then
+      skiptask instsoft || true
+   fi
+
+   exit # make sure we don't continue behind the following "fi"
 fi
 
+if [ -n "$BOOTSTRAP_ONLY" ] ; then
+  echo "Skipping task configure in hooks/updatebase.GRMLBASE as BOOTSTRAP_ONLY environment is set."
+  skiptask configure
+fi
+
+# no softupdate but updating chroot e.g. based on /etc/grml/fai/config/basefiles/*
+echo "Action $FAI_ACTION of FAI (hooks/updatebase.GRMLBASE) via grml-live running"
+
+# install all apt related files
+fcopy -r /etc/apt
+
+# remove grml-live's notice file from chroot:
+if [ -r $target/etc/apt/important_note.txt ] ; then
+   grep -q GRML_LIVE_SOURCES $target/etc/apt/important_note.txt && rm $target/etc/apt/important_note.txt
+fi
+
+# install grml gpg key:
+fcopy /etc/apt/grml.key
+$ROOTCMD apt-key add /etc/apt/grml.key
+
 ## END OF FILE #################################################################
 # vim:ft=sh expandtab ai tw=80 tabstop=4 shiftwidth=3